datablock ItemData(PlaceSentryRifleItem)
{
	category = "Item";  // Mission editor category
	
	shapeFile = "./sentryToolkitRifle.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Toolkit - Rifle";
	iconName = "./icon_sentry_rifle";
	doColorShift = false;
	colorShiftColor = "0.200 0.200 0.200 1.000";
	
	image = PlaceSentryRifleImage;
	canDrop = true;
};

datablock ShapeBaseImageData(PlaceSentryRifleImage : PlaceSentryImage)
{
   // Basic Item properties
   shapeFile = "./sentryToolkitRifle.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.

   //doColorShift = true;
	 //colorShiftColor = PlaceSentryRifleItem.colorShiftColor;
	 
   correctMuzzleVector = false;
   className = "ToolImage";
	 
   item = PlaceSentryRifleItem;

   //melee particles shoot from eye node for consistancy
   melee = true;
   //raise your arm up or not
   armReady = false;

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]       = "Ready";
	stateScript[0]                  = "onActivate";
	stateSequence[0]                  = "Activate";

	stateName[1]                     = "Ready";
	stateScript[1]                  = "onUse";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTriggerUp[2]	= "Ready";
	stateScript[2]                  = "onFire";

	minShotTime = 20000;
};

function PlaceSentryRifleImage::onMount(%this, %obj, %slot)
{
	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
		{
		centerprint(%obj.client,"Can't deploy another sentry yet!<br><br>Give it a minute or so to respawn..." ,5);
		serverCmdUnUseTool(%obj.client);
		%obj.playThread(2, undo);
		return;
		}

	%obj.playthread(1, armReadyBoth);
}

function PlaceSentryRifleImage::onActivate(%this, %obj, %slot)
{
	%obj.playthread(1, armReadyBoth);
	%obj.lastcrateslot = %obj.currTool;
}

function PlaceSentryRifleImage::onUnMount(%this,%obj,%slot)
{
		%obj.playThread(0, root);
}

function PlaceSentryRifleImage::onFire(%this, %obj, %slot)
{
	createRifleSentryAtPlayer(%obj.client.player);

	serverCmdUnUseTool(%obj.client);
	%obj.playThread(1, plant);
	%obj.playThread(2, activate2);

	%obj.lastFireTime = getSimTime();
  %fvec = %obj.getForwardVector();
  %fX = getWord(%fvec,0);
  %fY = getWord(%fvec,1);
  
  %evec = %obj.getEyeVector();
  %eX = getWord(%evec,0);
  %eY = getWord(%evec,1);
  %eZ = getWord(%evec,2);
  
  %eXY = mSqrt(%eX*%eX+%eY*%eY);
  
  %aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;

	%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%aimVec,"-8")));

  serverPlay3D(sentryBuildSound, %obj.getPosition());
}

function createRifleSentryAtPlayer(%player)
{
	if($sentryOnePerPlayer)
	{
		for(%i = 0; %i < sentryGroup.getCount(); %i++)
		{
			if(isObject(sentryGroup.getObject(%i).sentryOwner) && sentryGroup.getObject(%i).sentryOwner == %player.client)
			{
				sentryGroup.getObject(%i).kill();
			}
		}
	}
	%pos = vectorAdd(vectorScale(%player.getForwardVector(), 3) @ " 0 0 0 0", %player.getTransform());
	%bottom = new AIPlayer()
	{
		datablock = "PlayerSentryBottom";
		position = %pos;
		sentryOwner = %player.client;
		tdmTeam = %player.client.tdmTeam;
		sentryKit = "Default";
		sentryXP = 0;
	};
	%top = new AIPlayer()
	{
		datablock = "PlayerSentryTop";
		sentryBottom = %bottom;
		sentryOwner = %player.client;
		tdmTeam = %player.client.tdmTeam;
	};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////

%p = new Projectile()
  {
     dataBlock = toolboxExplosionProjectile;
     initialPosition = %pos;
     initialVelocity = "0 0 1";
     client = %obj.client;
     sourceClient = %obj.client;
  };

///////////////////////////////////////////////////////////////////////////////////////////////////////////////
	%top.client = %top;
	%top.player = %top;
	%top.minigame = %player.client.minigame;
	%top.sentryLevel = 1;
	%top.sentryKit = "Rifle";
	
	%bottom.client = %bottom;
	%bottom.player = %bottom;
	%bottom.minigame = %player.client.minigame;
	
	%top.hideNode("invisible");

	%bottom.mountObject(%top, 0);
	%top.setControlObject(%top); //must do this or it spins in circles
	
	%bottom.sentryTop = %top;
	sentryGroup.add(%top);	

	%top.mountImage($sentryImage_Rifle_1, 0);
	
	if(!isEventPending($sentryLogicLoopSched))
		sentryLogicLoop();
}