//$sentryImage_[KITNAME]_[LEVEL]
$sentryImage_Rifle_1 = "sentryGunRifleImage";
$sentryImage_Rifle_2 = "sentryLongRifleGunImage";
$sentryImage_Rifle_3 = "sentryGaussImage";

$sentryUpgradeThreshold_Rifle_2 = 400;
$sentryUpgradeThreshold_Rifle_3 = 400;

exec("add-ons/weapon_gun/server.cs");

datablock AudioProfile(sentryRifleSound)
{
   filename    = "./sentryRifle.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(sentryGaussSound)
{
   filename    = "./sentryGauss.wav";
   description = AudioClosest3d;
   preload = true;
};
//LEVEL 1======================================================================
//=============================================================================
//=============================================================================

AddDamageType("SentryRifle",   '%1 <bitmap:add-ons/Weapon_Sentry/CI_s_rifle1> %1',    '%2 <bitmap:add-ons/Weapon_Sentry/CI_s_rifle1> %1',0.75,1);
//projectile
datablock ProjectileData(sentryGunRifleProjectile)
{
   projectileShapeName = "add-ons/weapon_gun/bullet.dts";
   directDamage        = 40;
   directDamageType    = $DamageType::sentryRifle;
   radiusDamageType    = $DamageType::sentryRifle;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 1000;
   verticalImpulse	  = 400;
   explosion           = gunExplosion;
   particleEmitter     = ""; //bulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 0;

   armingDelay         = 00;
   lifetime            = 8000;
   fadeDelay           = 6500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Sentry Rifle Bullet";
};

//sentry gun datablock (weapon image)
datablock ShapeBaseImageData(sentryGunRifleImage)
{
   shapeFile = "./sentryRifle1.1.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;
   className = "WeaponImage";
	
   item = gunItem;
   ammo = " ";
   projectile = sentryGunRifleProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   melee = false;
   armReady = true;

   //doColorShift = true;
   //colorShiftColor = gunItem.colorShiftColor;//"0.400 0.196 0 1.000";

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 12.0;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSequence[0]	= "Activate";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateWaitForTimeout[1]		= false;
	stateWaitForTimeout[4]		= false;
	stateTimeoutValue[1]             = 2.5;
	stateTransitionOnTimeout[1]       = "Ready2";
	stateSound[1]					= sentryBeepSound;
	stateSequence[1]	= "look1";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.6;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= gunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= sentryRifleSound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Alerted";

	stateName[4]                     = "Ready2";
	stateTransitionOnTriggerDown[4]  = "Fire";
	stateAllowImageChange[4]         = true;
	stateTimeoutValue[4]             = 2.5;
	stateTransitionOnTimeout[4]       = "Ready";
	stateSound[4]					= sentryBeepSound;
	stateSequence[4]	= "look2";

	stateName[5] = "Alerted";
	stateTransitionOnTriggerDown[5]  = "Fire";
	stateWaitForTimeout[5]		= false;
	stateTimeoutValue[5]            = 2.5;
	stateTransitionOnTimeout[5]     = "Ready";
};

function sentryGunRifleImage::onFire(%this, %obj, %slot)
{
	%projectile = %this.projectile;
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj.client.player;
		sourceSlot = %slot;
		client = %obj.sentryOwner;
	};
	MissionCleanup.add(%p);
	return %p;
}

//LEVEL 2======================================================================
//=============================================================================
//=============================================================================

AddDamageType("SentryRifle2",   '%1 <bitmap:add-ons/Weapon_Sentry/CI_s_rifle2> %1',    '%2 <bitmap:add-ons/Weapon_Sentry/CI_s_rifle2> %1',0.75,1);
//projectile
datablock ProjectileData(sentryLongRifleGunProjectile)
{
   projectileShapeName = "add-ons/weapon_gun/bullet.dts";
   directDamage        = 60;
   directDamageType    = $DamageType::sentryRifle2;
   radiusDamageType    = $DamageType::sentryRifle2;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 1250;
   verticalImpulse	  = 400;
   explosion           = gunExplosion;
   particleEmitter     = gunSmokeEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 0;

   armingDelay         = 00;
   lifetime            = 8000;
   fadeDelay           = 6500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Sentry Long Bullet";
};

datablock ShapeBaseImageData(sentryLongRifleGunImage)
{
   shapeFile = "./sentryRifle2.1.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;
   className = "WeaponImage";
	
   item = gunItem;
   ammo = " ";
   projectile = sentryLongRifleGunProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   melee = false;
   armReady = true;

   //doColorShift = true;
   //colorShiftColor = gunItem.colorShiftColor;//"0.400 0.196 0 1.000";

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateWaitForTimeout[1]		= false;
	stateWaitForTimeout[4]		= false;
	stateTimeoutValue[1]             = 2.5;
	stateTransitionOnTimeout[1]       = "Ready2";
	stateSound[1]					= sentryBeepSound;
	stateSequence[1]	= "look1";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.6;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= gunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= sentryRifleSound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Alerted";

	stateName[4]                     = "Ready2";
	stateTransitionOnTriggerDown[4]  = "Fire";
	stateAllowImageChange[4]         = true;
	stateTimeoutValue[4]             = 2.5;
	stateTransitionOnTimeout[4]       = "Ready";
	stateSound[4]					= sentryBeepSound;
	stateSequence[4]	= "look2";

	stateName[5] = "Alerted";
	stateTransitionOnTriggerDown[5]  = "Fire";
	stateWaitForTimeout[5]		= false;
	stateTimeoutValue[5]            = 2.5;
	stateTransitionOnTimeout[5]     = "Ready";
};

function sentryLongRifleGunImage::onFire(%this, %obj, %slot)
{
	%projectile = %this.projectile;
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj.client.player;
		sourceSlot = %slot;
		client = %obj.sentryOwner;
	};
	MissionCleanup.add(%p);
	return %p;
}

//LEVEL 3======================================================================
//=============================================================================
//=============================================================================

AddDamageType("SentryRifle3",   '%1 <bitmap:add-ons/Weapon_Sentry/CI_s_rifle3> %1',    '%2 <bitmap:add-ons/Weapon_Sentry/CI_s_rifle3> %1',0.75,1);
//projectile
datablock ProjectileData(sentryGaussProjectile)
{
   projectileShapeName = "add-ons/weapon_gun/bullet.dts";
   directDamage        = 80;
   directDamageType    = $DamageType::sentryRifle3;
   radiusDamageType    = $DamageType::sentryRifle3;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 1500;
   verticalImpulse	  = 400;
   explosion           = gunExplosion;
   particleEmitter     = gunExplosionEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 0;

   armingDelay         = 00;
   lifetime            = 8000;
   fadeDelay           = 6500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Gauss Bullet";
};

datablock ShapeBaseImageData(sentryGaussImage)
{
   shapeFile = "./sentryGauss.1.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;
   className = "WeaponImage";
	
   item = gunItem;
   ammo = " ";
   projectile = sentryGaussProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   melee = false;
   armReady = true;

   //doColorShift = true;
   //colorShiftColor = gunItem.colorShiftColor;//"0.400 0.196 0 1.000";

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateTimeoutValue[1]             = 2.5;
	stateWaitForTimeout[1]		= false;
	stateWaitForTimeout[4]		= false;
	stateTransitionOnTimeout[1]       = "Ready2";
	stateSound[1]					= sentryBeepSound;
	stateSequence[1]	= "look1";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.6;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= gunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= sentryGaussSound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Alerted";

	stateName[4]                     = "Ready2";
	stateTransitionOnTriggerDown[4]  = "Fire";
	stateAllowImageChange[4]         = true;
	stateTimeoutValue[4]             = 2.5;
	stateTransitionOnTimeout[4]       = "Ready";
	stateSound[4]					= sentryBeepSound;
	stateSequence[4]	= "look2";

	stateName[5] = "Alerted";
	stateTransitionOnTriggerDown[5]  = "Fire";
	stateWaitForTimeout[5]		= false;
	stateTimeoutValue[5]            = 2.5;
	stateTransitionOnTimeout[5]     = "Ready";
};

function sentryGaussImage::onFire(%this, %obj, %slot)
{
	%projectile = %this.projectile;
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj.client.player;
		sourceSlot = %slot;
		client = %obj.sentryOwner;
	};
	MissionCleanup.add(%p);
	return %p;
}